package za.co.sean.test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.docx4j.dml.Graphic;
import org.docx4j.dml.GraphicData;
import org.docx4j.dml.picture.Pic;
import org.docx4j.dml.wordprocessingDrawing.Anchor;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.wml.Drawing;
import org.docx4j.wml.P;
import org.docx4j.wml.R;
import org.docx4j.wml.Text;

public class DocumentAnalyzer {

	private static final String IMAGE_RETRIEVAL_EXCEPTION = "Exception occurred whilst trying to retrieve image object from document : Message : ";
	private static final String LIST_OBJECTS_RETRIEVAL_EXCEPTION = "Exception occurred whilst trying to retrieve the list of objects from document : Message : ";
	
	public static List<Object> extractAllObjectsFromDocument(WordprocessingMLPackage wordprocessingMLPackage) throws Exception {
		
		List<Object> theObjects = new ArrayList<Object>();
		try{
			theObjects = wordprocessingMLPackage.getMainDocumentPart().getJaxbElement().getBody().getEGBlockLevelElts(); 
		}catch (Exception e) {
			throw new Exception(DocumentAnalyzer.LIST_OBJECTS_RETRIEVAL_EXCEPTION + e.getMessage());
		}
		return theObjects;
	}
	
	@SuppressWarnings("unchecked")
	public static HashMap<String, Pic> extractAllRelationshipsAndImagesFromDocument(WordprocessingMLPackage wordprocessingMLPackage) throws Exception {
		
		HashMap<String, Pic> imagesInDocument = new HashMap<String, Pic>();
		try{
			List<Object> theObjects = DocumentAnalyzer.extractAllObjectsFromDocument(wordprocessingMLPackage);
			
			System.out.println("THE OBJECTS SIZE : " + theObjects.size());
			
			Iterator<Object> collectionIterator = theObjects.iterator();
			while(collectionIterator.hasNext()){
				try{
					P p = (P) collectionIterator.next();
					List<Object> paragraphObjects = p.getParagraphContent();
					Iterator<Object> collection2Iterator = paragraphObjects.iterator();
					while(collection2Iterator.hasNext()){
						try{
							R r = (R) collection2Iterator.next();
							List<Object> collectionR = r.getRunContent();
							Iterator<Object> collectionRIterator = collectionR.iterator();
							while(collectionRIterator.hasNext()){								
								try{
									Object element = collectionRIterator.next();									
									if(element instanceof javax.xml.bind.JAXBElement){
										javax.xml.bind.JAXBElement anElement = (javax.xml.bind.JAXBElement) element;
										if(anElement.getValue() instanceof Text){
											// would have used -> Text text = (Text) element.getValue();
											// do nothing here...
										}else if(anElement.getValue() instanceof Drawing){
											Drawing drawing = (Drawing) anElement.getValue();
											List<Object> aListing = drawing.getAnchorOrInline();
											Iterator<Object> collectionDrawingIterator = aListing.iterator();
											while(collectionDrawingIterator.hasNext()){
												org.docx4j.dml.wordprocessingDrawing.Inline inlineDrawing = (org.docx4j.dml.wordprocessingDrawing.Inline) collectionDrawingIterator.next();
												//Anchor inlineDrawing = (Anchor)collectionDrawingIterator.next();
												Graphic theGRaphic = (Graphic) inlineDrawing.getGraphic();
												GraphicData theGraphicData = theGRaphic.getGraphicData();
												System.out.println("ADD IMAGE FOUND TO HASHMAP : " + theGraphicData.getPic().getBlipFill().getBlip().getEmbed());
												imagesInDocument.put(theGraphicData.getPic().getBlipFill().getBlip().getEmbed(), theGraphicData.getPic());
											}
										}
									}
								}catch (Exception e) {
									e.printStackTrace();
								}
							}
						}catch (Exception e) {
							// do nothing...
							System.out.println("AN EXCEPTION ON R !");
						}
					}
				}catch (Exception e) {
					// do nothing...
					System.out.println("AN EXCEPTION ON P !");
				}
			}
			
		}catch (Exception e) {
			throw new Exception(DocumentAnalyzer.IMAGE_RETRIEVAL_EXCEPTION + e.getMessage());
		}
		return imagesInDocument;
	}	
}
