package za.co.sean.test;

import java.io.File;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import javax.xml.bind.JAXBContext;

import org.docx4j.convert.out.html.AbstractHtmlExporter;
import org.docx4j.convert.out.html.HtmlExporterNG;
import org.docx4j.convert.out.pdf.PdfConversion;
import org.docx4j.dml.CTBlip;
import org.docx4j.dml.picture.Pic;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.BinaryPartAbstractImage;
import org.docx4j.openpackaging.parts.WordprocessingML.FooterPart;
import org.docx4j.openpackaging.parts.WordprocessingML.HeaderPart;
import org.docx4j.openpackaging.parts.relationships.RelationshipsPart;
import org.docx4j.relationships.Relationship;
import org.docx4j.wml.FooterReference;
import org.docx4j.wml.Ftr;
import org.docx4j.wml.Hdr;
import org.docx4j.wml.HdrFtrRef;
import org.docx4j.wml.HeaderReference;
import org.docx4j.wml.ObjectFactory;
import org.docx4j.wml.SectPr;

public class DocumentManipulatorTest {

	public static JAXBContext context = org.docx4j.jaxb.Context.jc;

	private static ObjectFactory objectFactory = new ObjectFactory();

	private static final String TEMPLATE_FOLDER = "C:/TestPickupFolderTemplates/";
		
	private static final String BODY_TEMPLATE_NAME = "body.docx";
	//private static final String HEADER_TEMPLATE_NAME = "header.docx";
	private static final String HEADER_TEMPLATE_NAME = "headerWithImages.docx";
	//private static final String FOOTER_TEMPLATE_NAME = "footer.docx";
	private static final String FOOTER_TEMPLATE_NAME = "footerWithImages.docx";
	private static final String FOR_HTML_EXPORT_TEMPLATE = "ForHTMLExport.docx";
	
	private static final String BODY_TEMPLATE_NAME_UPDATED = "zbody_Updated.docx";
	private static final String FOR_HTML_EXPORT_TEMPLATE_UPDATED = "zForHTMLExportUpdated.docx";
	private static final String SAVED_HTML_FILE_FOLDER_WITH_OTHER_FILES = "zConvertedToHTMLFile_files";
	private static final String SAVED_HTML_FILE = "zConvertedToHTMLFile.html";
	
	private static final String SAVED_FILE_NAME = "zMergedOutputDocument.docx";
	private static final String MERGED_PDF_OUTPUT_FILE = "zMergedOutputPDFDocument.pdf";
	
	public DocumentManipulatorTest() {

		try {

			long start = System.currentTimeMillis();
			
			// ************************************************************************************************************* //
			
			// Replace Mail Merge Tags with Values
			WordprocessingMLPackage wordprocessingMLPackageBody = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + BODY_TEMPLATE_NAME));
			WordprocessingMLPackage wordprocessingMLPackageForHTML = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + FOR_HTML_EXPORT_TEMPLATE));
			DocumentTextReplacer.replaceMailMergeTagsWithValues(wordprocessingMLPackageBody, TEMPLATE_FOLDER + BODY_TEMPLATE_NAME_UPDATED);
			DocumentTextReplacer.replaceMailMergeTagsWithValues(wordprocessingMLPackageForHTML, TEMPLATE_FOLDER + FOR_HTML_EXPORT_TEMPLATE_UPDATED);
			
			// ************************************************************************************************************* //
			
			// Load all templates
			WordprocessingMLPackage wordprocessingMLPackageHeader = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + HEADER_TEMPLATE_NAME));
			WordprocessingMLPackage wordprocessingMLPackageFooter = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + FOOTER_TEMPLATE_NAME));
			wordprocessingMLPackageBody = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + BODY_TEMPLATE_NAME_UPDATED));
			wordprocessingMLPackageForHTML = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + FOR_HTML_EXPORT_TEMPLATE_UPDATED));
						
			wordprocessingMLPackageHeader.save(new java.io.File(TEMPLATE_FOLDER + "yHeader.xml"));
			wordprocessingMLPackageFooter.save(new java.io.File(TEMPLATE_FOLDER + "yFooter.xml"));
			wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER + "yBody.xml"));
			
			// ************************************************************************************************************* //
			
			// Analyze and Merge Old Header Footer Objects and Relationships Into Merged Document
			
			System.out.println("DOING HEADER FOOTER THING !");
			
			doTheHeaderFooterThing(wordprocessingMLPackageBody, wordprocessingMLPackageHeader, wordprocessingMLPackageFooter);
			
			wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER, SAVED_FILE_NAME));
			wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER, SAVED_FILE_NAME + ".xml"));

			// ************************************************************************************************************* //
			
			// Export to HTML			
			//AbstractHtmlExporter exporter = new HtmlExporterNG2(); // no text in html 1kb
			//AbstractHtmlExporter exporter = new HtmlExporter(); // works fine but removes line breaks and file is bigger 5kb
			AbstractHtmlExporter exporter = new HtmlExporterNG(); // works fine with line breaks and file is small 2kb
            OutputStream outStream = new java.io.FileOutputStream(TEMPLATE_FOLDER + SAVED_HTML_FILE);
            javax.xml.transform.stream.StreamResult result = new javax.xml.transform.stream.StreamResult(outStream);
            exporter.html(wordprocessingMLPackageForHTML, result, SAVED_HTML_FILE_FOLDER_WITH_OTHER_FILES);
			
			// ************************************************************************************************************* //
			
			// Export to PDF
			//org.docx4j.convert.out.pdf.PdfConversion c = new org.docx4j.convert.out.pdf.viaIText.Conversion(wordprocessingMLPackageBody);
			//org.docx4j.convert.out.pdf.PdfConversion c = new org.docx4j.convert.out.pdf.viaHTML.Conversion(wordprocessingMLPackageBody);
			org.docx4j.convert.out.pdf.PdfConversion pdfConversionObject = new org.docx4j.convert.out.pdf.viaXSLFO.Conversion(wordprocessingMLPackageBody);
			OutputStream theOutputStream = new java.io.FileOutputStream(TEMPLATE_FOLDER + MERGED_PDF_OUTPUT_FILE);
			PdfConversion.log("HELLO A MESSAGE 1!");
			PdfConversion.log("HELLO A MESSAGE 2!");
			PdfConversion.log("HELLO A MESSAGE 3!");
			PdfConversion.log("HELLO A MESSAGE 4!");
			pdfConversionObject.output(theOutputStream);
			PdfConversion.log("HELLO A MESSAGE 5 DONE DONE DONE WITH CONVERSION NOW !");
			
            // PDFCREATOR STUFFS !!!!!!!!!!!!!!
			//String executableString = "pdfcreator.exe /PF" + "C:\\TestPickupFolderTemplates\\" + SAVED_FILE_NAME; 
			//System.out.println("executableString : " + executableString);
			//Runtime.getRuntime().exec(executableString);
			
			long end = System.currentTimeMillis();
			long duration = end - start;
			
			System.out.println("The duration of entire process took " + duration + " millisecond(s)...");
			
			// ************************************************************************************************************* //

		} catch (Exception e) {
			
			System.out.println(" ");
			System.out.println("EXCEPTION OCCURRED : " + e.getMessage());
			System.out.println(" ");
			e.printStackTrace();
		}
	}
	
	private void doTheHeaderFooterThing(WordprocessingMLPackage wordprocessingMLPackageBody,
										WordprocessingMLPackage wordprocessingMLPackageHeader,
										WordprocessingMLPackage wordprocessingMLPackageFooter) throws Exception {
		
		System.out.println("CHECKING 4 IMAGES ON BODY !");
		HashMap<String, Pic> bodyImagesAndRelationships = DocumentAnalyzer.extractAllRelationshipsAndImagesFromDocument(wordprocessingMLPackageBody);
		System.out.println("CHECKING 4 IMAGES ON HEADER !");
		HashMap<String, Pic> headerImagesAndRelationships = DocumentAnalyzer.extractAllRelationshipsAndImagesFromDocument(wordprocessingMLPackageHeader);
		System.out.println("CHECKING 4 IMAGES ON FOOTER !");
		HashMap<String, Pic> footerImagesAndRelationships = DocumentAnalyzer.extractAllRelationshipsAndImagesFromDocument(wordprocessingMLPackageFooter);
	
		System.out.println("* bodyImagesAndRelationships   : SIZE : " + bodyImagesAndRelationships.size());
		System.out.println("* headerImagesAndRelationships : SIZE : " + headerImagesAndRelationships.size());
		System.out.println("* footerImagesAndRelationships : SIZE : " + footerImagesAndRelationships.size());
		
		Set<String> bodySet = bodyImagesAndRelationships.keySet();
		Set<String> headerSet = headerImagesAndRelationships.keySet();
		Set<String> footerSet = footerImagesAndRelationships.keySet();
		
//		// Body Image relationship replacements...
//		String oldRelId = "";
//		Iterator<String> bodySetIterator = bodySet.iterator();
//		while(bodySetIterator.hasNext()){
//			Pic theBodyPic = bodyImagesAndRelationships.get(bodySetIterator.next());
//			oldRelId = theBodyPic.getBlipFill().getBlip().getEmbed();
//			System.out.println("Found image on body : rId : " + oldRelId);
//			theBodyPic.getBlipFill().getBlip().setEmbed("99");
//			System.out.println("Set image on body   : rId : " + theBodyPic.getBlipFill().getBlip().getEmbed());
//			
//		}
//		
//		wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER + BODY_TEMPLATE_NAME_UPDATED));
//		wordprocessingMLPackageBody = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + BODY_TEMPLATE_NAME_UPDATED));
//		wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER + "yBodyRIdFixedUp.xml"));
		
		//System.out.println("Finished changing rId for images on body and saved it and loaded it again !");
		
		// Header
		HeaderPart headerPart = new HeaderPart();
		Hdr hdr = objectFactory.createHdr();
		// This only adds all text found and image place holders to the hdr...
		hdr.getEGBlockLevelElts().addAll(DocumentAnalyzer.extractAllObjectsFromDocument(wordprocessingMLPackageHeader));
		headerPart.setJaxbElement(hdr);
		// Add the new header relationship to this header part.. 
		Relationship newHeaderRelationship = wordprocessingMLPackageBody.getMainDocumentPart().addTargetPart(headerPart);
		
		// Footer
		FooterPart footerPart = new FooterPart();
		Ftr ftr = objectFactory.createFtr();
		// This only adds all text found and image place holders to the ftr... 
		ftr.getEGBlockLevelElts().addAll(DocumentAnalyzer.extractAllObjectsFromDocument(wordprocessingMLPackageFooter));
		footerPart.setJaxbElement(ftr);
		// Add the new footer relationship to this header part.. 
		Relationship newFooterRelationship = wordprocessingMLPackageBody.getMainDocumentPart().addTargetPart(footerPart);
		
		Iterator<String> headerSetIterator = headerSet.iterator();
		while(headerSetIterator.hasNext()){
			Pic theHeaderPic = headerImagesAndRelationships.get(headerSetIterator.next());
			// Get a reference to the blip for later
			CTBlip picBlip = theHeaderPic.getBlipFill().getBlip();
			// 1. Get placeholder on body rel id...
			Relationship existing = wordprocessingMLPackageHeader.getMainDocumentPart().getRelationshipsPart().getRelationshipByID(picBlip.getEmbed());
			// 2. Get actual embedded image on old header using existing relationship extracted from old header...
			BinaryPartAbstractImage binaryPart = (BinaryPartAbstractImage)wordprocessingMLPackageHeader.getMainDocumentPart().getRelationshipsPart().getPart(existing);
			// 3. Get data from image on old header as byte array...
			ByteBuffer byteBuffer = binaryPart.getBuffer();
			byteBuffer.clear();
	        byte[] bytes = new byte[byteBuffer.capacity()];
	        byteBuffer.get(bytes, 0, bytes.length);
	        // 4. Ensure relationship part on new header part...
	        if (headerPart.getRelationshipsPart() == null) {
				// 4.a If not then create it now...
				RelationshipsPart relationshipPart = new RelationshipsPart(headerPart);
				relationshipPart.setPackage(headerPart.getPackage());
				headerPart.setRelationships(relationshipPart);
				// 4.b Make sure content manager knows how to handle .rels...
				headerPart.getPackage().getContentTypeManager().addDefaultContentType("rels", org.docx4j.openpackaging.contenttype.ContentTypes.RELATIONSHIPS_PART);
			}
	        // 5. Create an image from the byte [ ] on body here...
	        BinaryPartAbstractImage copiedImagePart = BinaryPartAbstractImage.createImagePart(wordprocessingMLPackageBody, headerPart, bytes);
	        // 6. Correct relationship - The only problem now is that the rel ref in the doc is probably not the same as the rel just created so fix it now...
	        String newRel = copiedImagePart.getSourceRelationship().getId();
	        picBlip.setEmbed(newRel);
		}
		
		HeaderReference headerReference = objectFactory.createHeaderReference();
		headerReference.setId(newHeaderRelationship.getId());
		headerReference.setType(HdrFtrRef.DEFAULT); // FIRST / DEFAULT / EVEN
		
		Iterator<String> footerSetIterator = footerSet.iterator();
		while(footerSetIterator.hasNext()){
			Pic theFooterPic = footerImagesAndRelationships.get(footerSetIterator.next());
			// Get a reference to the blip for later...
			CTBlip picBlip = theFooterPic.getBlipFill().getBlip();
			// 1. Get placeholder on body rel id...
			Relationship existing = wordprocessingMLPackageFooter.getMainDocumentPart().getRelationshipsPart().getRelationshipByID(picBlip.getEmbed());
			// 2. Get actual embedded image on old footer using existing relationship extracted from old header...
			BinaryPartAbstractImage binaryPart = (BinaryPartAbstractImage)wordprocessingMLPackageFooter.getMainDocumentPart().getRelationshipsPart().getPart(existing);
			// 3. Get data from image on old footer as byte array...
			ByteBuffer byteBuffer = binaryPart.getBuffer();
			byteBuffer.clear();
	        byte[] bytes = new byte[byteBuffer.capacity()];
	        byteBuffer.get(bytes, 0, bytes.length);
	        // 4. Ensure relationship part on new footer part
	        if (footerPart.getRelationshipsPart() == null) {
				// 4.a If not then create it now...
				RelationshipsPart relationshipPart = new RelationshipsPart(footerPart);
				relationshipPart.setPackage(footerPart.getPackage());
				footerPart.setRelationships(relationshipPart);
				// 4.b Make sure content manager knows how to handle .rels
				footerPart.getPackage().getContentTypeManager().addDefaultContentType("rels", org.docx4j.openpackaging.contenttype.ContentTypes.RELATIONSHIPS_PART);
			}
	        // 5. Create an image from the byte [ ] on body here...
	        BinaryPartAbstractImage copiedImagePart = BinaryPartAbstractImage.createImagePart(wordprocessingMLPackageBody, footerPart, bytes);
	        // 6. Correct relationship - The only problem now is that the rel ref in the doc is probably not the same as the rel just created so fix it now...
	        String newRel = copiedImagePart.getSourceRelationship().getId();
	        picBlip.setEmbed(newRel);
		}
		
		FooterReference footerReference = objectFactory.createFooterReference();
		footerReference.setId(newFooterRelationship.getId());
		footerReference.setType(HdrFtrRef.DEFAULT); // FIRST / DEFAULT / EVEN
		
		// ************************************************************************************************************* //
		
		// SectPr
		SectPr sectPr = objectFactory.createSectPr();
		sectPr.getEGHdrFtrReferences().add(headerReference);
		sectPr.getEGHdrFtrReferences().add(footerReference);
		
		//wordprocessingMLPackageBody.getMainDocumentPart().addObject(sectPr);
		wordprocessingMLPackageBody.getMainDocumentPart().getJaxbElement().getBody().setSectPr(sectPr);
		
		wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER + BODY_TEMPLATE_NAME_UPDATED));
		wordprocessingMLPackageBody = WordprocessingMLPackage.load(new java.io.File(TEMPLATE_FOLDER + BODY_TEMPLATE_NAME_UPDATED));
		wordprocessingMLPackageBody.save(new java.io.File(TEMPLATE_FOLDER + "yBodyRIdFixedUp.xml"));

		// ************************************************************************************************************* //
	}	

	public static void main(String[] arguments) {
		new DocumentManipulatorTest();
	}
}
